#include "kyokumen.h"

#include <memory.h>
#include <stdlib.h>

uint64 Kyokumen::HashSeed[ERY+1][0x99+1];
uint64 Kyokumen::HandHashSeed[EHI+1][18+1];

uint64 Kyokumen::HashHistory[1000];
int Kyokumen::OuteHistory[1000];

void Kyokumen::HashInit()
{
	int i;
	for(i=0;i<=ERY;i++) {
		for(int pos=0x11;pos<=0x99;pos++) {
			HashSeed[i][pos]=((uint64)rand())<<49|
							 ((uint64)rand())<<34|
							 ((uint64)rand())<<19|
							 ((uint64)rand())<<4|
							  rand() & 0x07;
		}
	}
	
	for(i=SFU;i<=EHI;i++) {
		for(int maisuu=0;maisuu<=18;maisuu++) {
			HandHashSeed[i][maisuu]=((uint64)rand())<<49|
								 ((uint64)rand())<<34|
								 ((uint64)rand())<<19|
								 ((uint64)rand())<<4|
								  rand() & 0x07;
		}
	}
}



// ǖʂ̃RXgN^FՖʂ̏ԂƎ萔A琶
Kyokumen::Kyokumen(int tesu,KomaInf board[9][9],int Motigoma[])
{
	// ՖʂWALLiǁjŖ߂Ă܂B
	memset(banpadding,WALL,sizeof(banpadding));
	memset(ban,WALL,sizeof(ban));
	// 
	value=0;
	printf("value:%d\n");
	kingS=0;
	kingE=0;
	Tesu=tesu;

	HashVal=0;
	HandHashVal=0;
	KyokumenHashVal=0;
	// boardŗ^ꂽǖʂݒ肵܂B
	for(int dan=1;dan<=9;dan++) {
		for(int suji=0x10;suji<=0x90;suji+=0x10) {
			// ̋؂͍EȂ̂ŁAz̐錾ƋtɂȂ邽߁A؂͂ЂԂȂƂȂ܂B
			ban[suji+dan]=board[dan-1][9-suji/0x10];
			KyokumenHashVal^=HashSeed[ban[suji+dan]][suji+dan];
			if (ban[suji+dan]==SOU) {
				kingS=suji+dan;
			}
			if (ban[suji+dan]==EOU) {
				kingE=suji+dan;
			}
			value+=KomaValue[ban[suji+dan]];
		}
	}
	// ͂̂܂ܗp܂B
	int i;
	for(i=0;i<=EHI;i++) {
		Hand[i]=Motigoma[i];
		value+=HandValue[i]*Hand[i];
		for(int j=1;j<=Hand[i];j++) {
			HandHashVal^=HandHashSeed[i][j];
		}
	}
	HashVal=KyokumenHashVal^HandHashVal;
	for(i=0;i<Tesu;i++) {
		HashHistory[i]=0;
		OuteHistory[i]=0;
	}
	HashHistory[Tesu]=HashVal;
	OuteHistory[Tesu]=((Tesu%2)==0)?controlS[kingE]:controlE[kingS];
	// controlS/controlE܂B
	InitControl();
}

// controlS,controlȄ
void Kyokumen::InitControl()
{
	int dan, suji;
	int i, j, b, bj;

	memset(controlS,0,sizeof(controlS));
	memset(controlE,0,sizeof(controlE));

	for (suji = 0x10; suji <= 0x90; suji += 0x10) {
		for (dan = 1 ; dan <= 9 ; dan++) {
			if (ban[suji + dan] & ENEMY) { //G̋
				//̌ǉ
				for (i = 0, b = 1, bj = (1<<16); i < 12; i++, b<<=1, bj<<=1) {
					if (CanJump[i][ban[dan + suji]]) {
						j = dan + suji;
						do {
							j += Direct[i];
							controlE[j] |= bj;
						} while (ban[j] == EMPTY);
					} else if (CanMove[i][ban[dan + suji]]) {
						controlE[dan + suji + Direct[i]] |= b;
					}
				}
			} else if (ban[suji + dan] & SELF) { //̋L
				//̌ǉ
				for (i = 0, b = 1, bj = (1<<16); i < 12; i++, b<<=1, bj<<=1) {
					if (CanJump[i][ban[dan + suji]]) {
						j = dan + suji;
						do {
							j += Direct[i];
							controlS[j] |= bj;
						} while (ban[j] == EMPTY);
					} else if (CanMove[i][ban[dan + suji]]) {
						controlS[dan + suji + Direct[i]] |= b;
					}
				}
			}	
		}
	}
}

// ŋǖʂi߂
void Kyokumen::Move(int SorE,const Te &te)
{
	int i,j,b,bj;
	if (te.from>0x10) {
		// ̃Rg[
		int dir;
		for(dir=0,b=1,bj=1<<16;dir<12;dir++,b<<=1,bj<<=1) {
			if (SorE==SELF) {
				controlS[te.from+Direct[dir]]&=~b;
			} else {
				controlE[te.from+Direct[dir]]&=~b;
			}
			if (CanJump[dir][te.koma]) {
				int j = te.from;
				do {
					j += Direct[dir];
					if (SorE==SELF) {
						controlS[j] &= ~bj;
					} else {
						controlE[j] &= ~bj;
					}
				} while (ban[j] == EMPTY);
			}
		}
		// ʒu͋󔒂ɂȂ
		ban[te.from]=EMPTY;
		// 󔒂ɂȂƂŕςnbVl
		KyokumenHashVal^=HashSeed[te.koma][te.from];
		KyokumenHashVal^=HashSeed[EMPTY][te.from];
		// їL΂
		for (i = 0, bj = (1<<16); i < 8; i++, bj<<=1) {
			int Dir=Direct[i];
			if (controlS[te.from] & bj) {
				j = te.from;
				do {
					j += Dir;
					controlS[j] |= bj;
				} while (ban[j] == EMPTY);
			}
			if (controlE[te.from] & bj) {
				j = te.from;
				do {
					j += Dir;
					controlE[j] |= bj;
				} while (ban[j] == EMPTY);
			}
		}
	} else {
		// ꖇ炷
		HandHashVal^=HandHashSeed[te.koma][Hand[te.koma]];
		Hand[te.koma]--;
		value-=HandValue[te.koma];
		value+=KomaValue[te.koma];
	}
	if (ban[te.to]!=EMPTY) {
		// ̋ɂB
		// ɂ鎞́AĂsɖ߂Bi&~PROMOTEDj
		value-=KomaValue[ban[te.to]];
		value+=HandValue[SorE|(ban[te.to]&~PROMOTED&~SELF&~ENEMY)];
		int koma=SorE|(ban[te.to]&~PROMOTED&~SELF&~ENEMY);
		Hand[koma]++;
		// nbVɎ
		HandHashVal^=HandHashSeed[koma][Hand[koma]];
		//̌
		for (i = 0, b = 1, bj = (1<<16); i < 12; i++, b<<=1, bj<<=1) {
			int Dir=Direct[i];
			if (CanJump[i][ban[te.to]]) {
				j = te.to;
				do {
					j += Dir;
					if (SorE==SELF) {
						controlE[j] &= ~bj;
					} else {
						controlS[j] &= ~bj;
					}
				} while (ban[j] == EMPTY);
			} else {
				j=te.to + Dir;
				if (SorE==SELF) {
					controlE[j] &= ~b;
				} else {
					controlS[j] &= ~b;
				}
			}
		}
	} else {
		// ړŎՂї
		for (i = 0, bj = (1<<16); i < 8; i++, bj<<=1) {
			int Dir=Direct[i];
			if (controlS[te.to] & bj) {
				j = te.to;
				do {
					j += Dir;
					controlS[j] &= ~bj;
				} while (ban[j] == EMPTY);
			}
			if (controlE[te.to] & bj) {
				j = te.to;
				do {
					j += Dir;
					controlE[j] &= ~bj;
				} while (ban[j] == EMPTY);
			}
		}
	}
	// ban[te.to]ɂ̂g
	KyokumenHashVal^=HashSeed[ban[te.to]][te.to];
	if (te.promote) {
		value-=KomaValue[te.koma];
		value+=KomaValue[te.koma|PROMOTED];
		ban[te.to]=te.koma|PROMOTED;
	} else {
		ban[te.to]=te.koma;
	}
	// Vgɉ
	KyokumenHashVal^=HashSeed[ban[te.to]][te.to];
	// ړ̗
	for (i = 0, b = 1, bj = (1<<16); i < 12; i++, b<<=1, bj<<=1) {
		if (CanJump[i][ban[te.to]]) {
			j = te.to;
			do {
				j += Direct[i];
				if (SorE==SELF) {
					controlS[j] |= bj;
				} else {
					controlE[j] |= bj;
				}
			} while (ban[j] == EMPTY);
		} else if (CanMove[i][ban[te.to]]) {
			if (SorE==SELF) {
				controlS[te.to+Direct[i]] |= b;
			} else {
				controlE[te.to+Direct[i]] |= b;
			}
		}
	}
	// l̈ʒu͊oĂB
	if (te.koma==SOU) {
		kingS=te.to;
	}
	if (te.koma==EOU) {
		kingE=te.to;
	}

	HashVal=KyokumenHashVal^HandHashVal;
	Tesu++;
	HashHistory[Tesu]=HashVal;
	OuteHistory[Tesu]=(SorE==SELF)?controlS[kingE]:controlE[kingS];
}

// siƉĂ܂̂œj̏Ԃݒ肷
void Kyokumen::MakePinInf(int *pin) const
{
	int i;
	// sݒ肷
	for (i = 0x11; i <= 0x99; i++) {
		// 0̓sĂȂAƂӖ
		pin[i] = 0;
	}
	if (kingS) {	//ʂՖʂɂ鎞̂ݗL
		for (i = 0; i < 8; i++) {
			int p;
			p = search(kingS, -Direct[i]); 
			if ((ban[p] != WALL) && !(ban[p] & ENEMY)) { //̋L
				if (controlE[p]&(1<<(16+i))) {
					pin[p]=Direct[i];
				}
			}
		}
	}
	if (kingE) {	//GʂՖʂɂ鎞̂ݗL
		for (i = 0; i < 8; i++) {
			int p;
			p = search(kingE, -Direct[i]);
			if ((ban[p] != WALL) && (ban[p] & ENEMY)) { //G̋L
				if (controlS[p]&(1<<(16+i))) {
					pin[p]=Direct[i];
				}
			}
		}
	}
}

// ̓ƂĐSĐB
int Kyokumen::MakeLegalMoves(int SorE,Te *teBuf,int *pin)
{
	int pbuf[16*11];
	int teNum=0;
	if (pin==NULL) {
		MakePinInf(pbuf);
		pin=pbuf;
	}
	if (SorE==SELF && controlE[kingS]!=0) {
		return AntiCheck(SorE,teBuf,pin,controlE[kingS]);
	}
	if (SorE==ENEMY && controlS[kingE]!=0) {
		return AntiCheck(SorE,teBuf,pin,controlS[kingE]);
	}

	int suji,dan;
	int StartDan,EndDan;
	// Տ̋𓮂
	for(suji=0x10;suji<=0x90;suji+=0x10) {
		for(dan=1;dan<=9;dan++) {
			if (ban[suji+dan]&SorE) {
				AddMoves(SorE,teNum,teBuf,suji+dan,pin[suji+dan]);
			}
		}
	}
	// ł
	if (Hand[SorE|FU]>0) {
		for(suji=0x10;suji<=0x90;suji+=0x10) {
			// `FbN
			int nifu=0;
			for(dan=1;dan<=9;dan++) {
				if (ban[suji+dan]==(SorE|FU)) {
					nifu=true;
					break;
				}
			}
			if (nifu) continue;
			//(ȂQiڂ艺ɁAȂWiڂɑłj
			if (SorE==SELF) {
				StartDan=2;
				EndDan=9;
			} else {
				StartDan=1;
				EndDan=8;
			}
			for(dan=StartDan;dan<=EndDan;dan++) {
				// łl߂`FbN
				if (ban[dan+suji]==EMPTY && !Utifudume(SorE,dan+suji,pin)) {
					teBuf[teNum++]=Te(0,suji+dan,SorE|FU,EMPTY);
				}
			}
		}
	}
	// ł
	if (Hand[SorE|KY]>0) {
		for(suji=0x10;suji<=0x90;suji+=0x10) {
			//(ȂQiڂ艺ɁAȂWiڂɑłj
			if (SorE==SELF) {
				StartDan=2;
				EndDan=9;
			} else {
				StartDan=1;
				EndDan=8;
			}
			for(dan=StartDan;dan<=EndDan;dan++) {
				if (ban[dan+suji]==EMPTY) {
					teBuf[teNum++]=Te(0,suji+dan,SorE|KY,EMPTY);
				}
			}
		}
	}
	//jł
	if (Hand[SorE|KE]>0) {
		//(ȂRiڂ艺ɁAȂViڂɑłj
		for(suji=0x10;suji<=0x90;suji+=0x10) {
			if (SorE==SELF) {
				StartDan=3;
				EndDan=9;
			} else {
				StartDan=1;
				EndDan=7;
			}
			for(dan=StartDan;dan<=EndDan;dan++) {
				if (ban[dan+suji]==EMPTY) {
					teBuf[teNum++]=Te(0,suji+dan,SorE|KE,EMPTY);
				}
			}
		}
	}
	// `Ԃ́AǂɂłłĂ
	for(int koma=GI;koma<=HI;koma++) {
		if (Hand[SorE|koma]>0) {
			for(suji=0x10;suji<=0x90;suji+=0x10) {
				for(dan=1;dan<=9;dan++) {
					if (ban[dan+suji]==EMPTY) {
						teBuf[teNum++]=Te(0,suji+dan,SorE|koma,EMPTY);
					}
				}
			}
		}
	}
	
	return teNum;
}

// Ֆʂfromɂ𓮂𐶐B
void Kyokumen::AddMoves(int SorE,int &teNum,Te *teTop,int from,int pin,int Rpin)
{
	switch(ban[from]) {
	case SFU:
		AddMove(SorE,teNum,teTop,from,-1,pin,Rpin);
		break;
	case EFU:
		AddMove(SorE,teNum,teTop,from,+1,pin,Rpin);
		break;
	case SKY:
		AddStraight(SorE,teNum,teTop,from,-1,pin,Rpin);
		break;
	case EKY:
		AddStraight(SorE,teNum,teTop,from,+1,pin,Rpin);
		break;
	case SKE:
		AddMove(SorE,teNum,teTop,from,+14,pin,Rpin);
		AddMove(SorE,teNum,teTop,from,-18,pin,Rpin);
		break;
	case EKE:
		AddMove(SorE,teNum,teTop,from,-14,pin,Rpin);
		AddMove(SorE,teNum,teTop,from,+18,pin,Rpin);
		break;
	case SGI:
		AddMove(SorE,teNum,teTop,from, -1,pin,Rpin);
		AddMove(SorE,teNum,teTop,from,-17,pin,Rpin);
		AddMove(SorE,teNum,teTop,from, 15,pin,Rpin);
		AddMove(SorE,teNum,teTop,from, 17,pin,Rpin);
		AddMove(SorE,teNum,teTop,from,-15,pin,Rpin);
		break;
	case EGI:
		AddMove(SorE,teNum,teTop,from, +1,pin,Rpin);
		AddMove(SorE,teNum,teTop,from, 17,pin,Rpin);
		AddMove(SorE,teNum,teTop,from,-15,pin,Rpin);
		AddMove(SorE,teNum,teTop,from,-17,pin,Rpin);
		AddMove(SorE,teNum,teTop,from, 15,pin,Rpin);
		break;
	case SKI:case STO:case SNY:case SNK:case SNG:
		AddMove(SorE,teNum,teTop,from, -1,pin,Rpin);
		AddMove(SorE,teNum,teTop,from,-17,pin,Rpin);
		AddMove(SorE,teNum,teTop,from, 15,pin,Rpin);
		AddMove(SorE,teNum,teTop,from, +1,pin,Rpin);
		AddMove(SorE,teNum,teTop,from,-16,pin,Rpin);
		AddMove(SorE,teNum,teTop,from, 16,pin,Rpin);
		break;
	case EKI:case ETO:case ENY:case ENK:case ENG:
		AddMove(SorE,teNum,teTop,from, +1,pin,Rpin);
		AddMove(SorE,teNum,teTop,from, 17,pin,Rpin);
		AddMove(SorE,teNum,teTop,from,-15,pin,Rpin);
		AddMove(SorE,teNum,teTop,from, -1,pin,Rpin);
		AddMove(SorE,teNum,teTop,from,-16,pin,Rpin);
		AddMove(SorE,teNum,teTop,from, 16,pin,Rpin);
		break;
	case SRY:case ERY:
		AddMove(SorE,teNum,teTop,from, 17,pin,Rpin);
		AddMove(SorE,teNum,teTop,from,-15,pin,Rpin);
		AddMove(SorE,teNum,teTop,from,-17,pin,Rpin);
		AddMove(SorE,teNum,teTop,from,+15,pin,Rpin);
	case SHI:case EHI:
		AddStraight(SorE,teNum,teTop,from,+1,pin,Rpin);
		AddStraight(SorE,teNum,teTop,from,-1,pin,Rpin);
		AddStraight(SorE,teNum,teTop,from,-16,pin,Rpin);
		AddStraight(SorE,teNum,teTop,from,+16,pin,Rpin);
		break;
	case SUM:case EUM:
		AddMove(SorE,teNum,teTop,from,+1,pin,Rpin);
		AddMove(SorE,teNum,teTop,from,+16,pin,Rpin);
		AddMove(SorE,teNum,teTop,from,-16,pin,Rpin);
		AddMove(SorE,teNum,teTop,from,-1,pin,Rpin);
	case SKA:case EKA:
		AddStraight(SorE,teNum,teTop,from,+17,pin,Rpin);
		AddStraight(SorE,teNum,teTop,from,-17,pin,Rpin);
		AddStraight(SorE,teNum,teTop,from,+15,pin,Rpin);
		AddStraight(SorE,teNum,teTop,from,-15,pin,Rpin);
		break;
	case SOU:case EOU:
		MoveKing(SorE,teNum,teTop,0);	// 肪Ă鎞ɂ́AAntiCheck̕Ă΂邩AKiki͂OłB
	}
}

// ꏊ̗쐬ĕԂBi͎gȂ֐ivZĂ邩jA
// łl߂̃`FbNȂǁAɒuĂ݂ĉ悤ȂƂɎgpB
Kiki Kyokumen::CountControlS(int pos)
{
	Kiki ret=0;
	int i,b,bj;
	b=1;
	bj=1<<16;
	for(i=0;i<12;i++,b<<=1,bj<<=1) {
		if (CanMove[i][ban[pos-Direct[i]]] && (ban[pos-Direct[i]]&SELF)) {
			ret|=b;
		} else if (CanJump[i][ban[search(pos,-Direct[i])]] && (ban[search(pos,-Direct[i])]&SELF)) {
			ret|=bj;
		}
	}
	return ret;
}

// ꏊ̗쐬ĕԂBi͎gȂ֐ivZĂ邩jA
// łl߂̃`FbNȂǁAɒuĂ݂ĉ悤ȂƂɎgpB
Kiki Kyokumen::CountControlE(int pos)
{
	Kiki ret=0;
	int i,b,bj;
	b=1;
	bj=1<<16;
	for(i=0;i<12;i++,b<<=1,bj<<=1) {
		if (CanMove[i][ban[pos-Direct[i]]] && (ban[pos-Direct[i]]&ENEMY)) {
			ret|=b;
		} else if (CanJump[i][ban[search(pos,-Direct[i])]] && (ban[search(pos,-Direct[i])]&ENEMY)) {
			ret|=bj;
		}
	}
	return ret;
}

// ꏊɈړłSW߂āAKikiɂĕԂB
// ̂ƂApinĂpin̕ɂȂB
Kiki Kyokumen::CountMove(int SorE,int pos,int *pin)
{
	Kiki ret=0;
	int i,b,bj;
	b=1;
	bj=1<<16;
	for(i=0;i<12;i++,b<<=1,bj<<=1) {
		if (CanMove[i][ban[pos-Direct[i]]] && (ban[pos-Direct[i]]&SorE) && (pin[pos-Direct[i]]==0||pin[pos-Direct[i]]==Direct[i]||pin[pos-Direct[i]]==-Direct[i])) {
			ret|=b;
		} else if (CanJump[i][ban[search(pos,-Direct[i])]] && (ban[search(pos,-Direct[i])]&SorE)&& (pin[search(pos,-Direct[i])]==0||pin[search(pos,-Direct[i])]==Direct[i]||pin[search(pos,-Direct[i])]==-Direct[i])) {
			ret|=bj;
		}
	}
	return ret;
}

// łl߂̔
int Kyokumen::Utifudume(int SorE,int to,int *pin)
{
	if (SorE==SELF) {
		// ܂Aʂ̓ɕł肶ȂΑłl߂̐Sz͂ȂB
		if (kingE+1!=to) {
			return 0;
		}
	} else {
		// ܂Aʂ̓ɕł肶ȂΑłl߂̐Sz͂ȂB
		if (kingS-1!=to) {
			return 0;
		}
	}
	//ۂɕłĊm߂Ă݂B
	ban[to]=FU|SorE;
	if (SorE==SELF) {
		// ̗瑊͋ʂŎȂ@@铮񋓂Ă݂ʂŎ肵Ȃ
		if (controlS[to] && (CountMove(ENEMY,to,pin)==1<<1)) {
			// ʂɓ邩ǂ`FbN
			for(int i=0;i<8;i++) {
				KomaInf koma=ban[kingE+Direct[i]];
				if (!(koma & ENEMY) && !CountControlS(kingE+Direct[i])) {
					// ̂ŁAՖʂ̏Ԃɖ߂āA
					ban[to]=EMPTY;
					// łl߂ł͂ȂB
					return 0;
				}
			}
			// ʂ̓Ȃ̂ȂAłl߁BՖʂ̏Ԃ͌ɖ߂B
			ban[to]=EMPTY;
			return 1;
		}
		// ʈȊOŎ肪邩AʂŎB
		ban[to]=EMPTY;
		return 0;
	} else {
		// ̗瑊͋ʂŎȂ@@铮񋓂Ă݂ʂŎ肵Ȃ
		if (controlE[to] && (CountMove(SELF,to,pin)==1<<6)) {
			// ʂɓ邩ǂ`FbN
			for(int i=0;i<8;i++) {
				KomaInf koma=ban[kingS+Direct[i]];
				if (!(koma & SELF) && !CountControlE(kingS+Direct[i])) {
					// ̂ŁAՖʂ̏Ԃɖ߂āA
					ban[to]=EMPTY;
					// łl߂ł͂ȂB
					return 0;
				}
			}
			// ʂ̓Ȃ̂ȂAłl߁BՖʂ̏Ԃ͌ɖ߂B
			ban[to]=EMPTY;
			return 1;
		}
		// ʈȊOŎ肪邩AʂŎB
		ban[to]=EMPTY;
		return 0;
	}
}

// ꏊitojɋł̐
void Kyokumen::PutTo(int SorE,int &teNum,Te *teTop,int to,int *pin)
{
	int dan=to &0x0f;
	if (SorE==ENEMY) {
		dan=10-dan;
	}
	if (Hand[SorE|FU]>0 && dan>1) {
		// ł𐶐
		// `FbN
		int suji=to & 0xf0;
		int nifu=0;
		for(int d=1;d<=9;d++) {
			if (ban[suji+d]==(SorE|FU)) {
				nifu=1;
				break;
			}
		}
		// łl߂`FbN
		if (!nifu && !Utifudume(SorE,to,pin)) {
			teTop[teNum++]=Te(0,to,SorE|FU,EMPTY);
		}
	}
	if (Hand[SorE|KY]>0 && dan>1) {
		// ł𐶐
		teTop[teNum++]=Te(0,to,SorE|KY,EMPTY);
	}
	if (Hand[SorE|KE]>0 && dan>2) {
		teTop[teNum++]=Te(0,to,SorE|KE,EMPTY);
	}
	for(int koma=GI;koma<=HI;koma++) {
		if (Hand[SorE|koma]>0) {
			teTop[teNum++]=Te(0,to,SorE|koma,EMPTY);
		}
	}
}

// 󂯂̐
int Kyokumen::AntiCheck(int SorE,Te *teBuf,int *pin,Kiki kiki)
{
	int king;
	int teNum=0;
	if ((kiki & (kiki-1))!=0) {
        //͋ʂ𓮂Ȃ
        MoveKing(SorE,teNum, teBuf, kiki);
	} else {
		if (SorE==SELF) {
			king=kingS;
		} else {
			king=kingE;
		}
		unsigned int id;
		int check;
        for (id = 0; id <= 31; id++) {
            if (kiki == (1u << id)) break;
        }
		if (id < 16) {
            check = king - Direct[id];
		} else {
			check = search(king,-Direct[id-16]);
		}
        //
        MoveTo(SorE,teNum, teBuf, check, pin);
		
        //ʂ𓮂
        MoveKing(SorE,teNum, teBuf, kiki);

		if (id >= 16) {
            //𐶐
            int i;
            for (i = king - Direct[id-16]; ban[i] == EMPTY; i -= Direct[id-16]) {
				MoveTo(SorE,teNum, teBuf, i, pin); //ړ
            }
            for (i = king - Direct[id-16]; ban[i] == EMPTY; i -= Direct[id-16]) {
				PutTo(SorE,teNum, teBuf, i, pin);  //ł
            }
        } 
	}
	return teNum;
}

// ʂ𓮂̐
// ʂ̋ƈႢÂ̗Ƃɂ͓Ȃ̂ŁÂ߂̓ȏĂ܂B
void Kyokumen::MoveKing(int SorE,int &teNum,Te *teTop,Kiki kiki)
{
	int i;
	int id = -1;	//אډ̈ʒuid
	// łȂȂ牤̈ʒuT
	for (i = 0; i < 8; i++) {
		if (kiki & (1 << i)) {
			id = i;
			break;
		}
	}
	if (id >= 0) {
		// אڂ̉ ŏɎ𐶐̂
		if (SorE==SELF) {
			KomaInf koma=ban[kingS-Direct[id]];
			if (( koma==EMPTY || (koma & ENEMY))
				&& !CountControlE(kingS - Direct[id]) //G̋ĂȂ
				&& !(kiki & (1 << (23-id))))  //G̔ŊтĂȂ
			AddMove(SorE,teNum, teTop, kingS, -Direct[id], 0);
		} else {
			KomaInf koma=ban[kingE-Direct[id]];
			if (( koma==EMPTY || (koma & SELF))
				&& !CountControlS(kingE - Direct[id]) //G̋ĂȂ
				&& !(kiki & (1 << (23-id))))  //G̔ŊтĂȂ
			AddMove(SorE,teNum, teTop, kingE, -Direct[id], 0);
		}
	}
	for (i = 0; i < 8; i++) {
		if (i == id) continue;
		if (SorE==SELF) {
			KomaInf koma=ban[kingS-Direct[i]];
			if (( koma==EMPTY || (koma & ENEMY))
				&& !CountControlE(kingS - Direct[i]) //G̋ĂȂ
				&& !(kiki & (1 << (23-i))))  //G̔ŊтĂȂ
			AddMove(SorE,teNum, teTop, kingS, -Direct[i], 0);
		} else {
			KomaInf koma=ban[kingE-Direct[i]];
			if (( koma==EMPTY || (koma & SELF))
				&& !CountControlS(kingE - Direct[i]) //G̋ĂȂ
				&& !(kiki & (1 << (23-i))))  //G̔ŊтĂȂ
			AddMove(SorE,teNum, teTop, kingE, -Direct[i], 0);
		}
	}
}

// ̐FEsӎāA̓𐶐B
void Kyokumen::AddMove(int SorE,int &teNum,Te *teTop,int from,int diff,int pin,int Rpin)
{
	if (Rpin==diff||Rpin==-diff) {
		return;
	}
	int to=from+diff;
	int dan=to&0x0f;
	int fromDan=from&0x0f;

	if ((pin==0 || pin==diff || pin==-diff) && !(ban[to]&SorE)) {
		if (ban[from]==SKE && dan<=2) {
			// K
			teTop[teNum++]=Te(from,to,ban[from],ban[to],1);
		} else if ((ban[from]==SFU || ban[from]==SKY) && dan<=1) {
			// K
			teTop[teNum++]=Te(from,to,ban[from],ban[to],1);
		} else if (ban[from]==EKE && dan>=8) {
			// K
			teTop[teNum++]=Te(from,to,ban[from],ban[to],1);
		} else if ((ban[from]==EFU || ban[from]==EKY) && dan>=9) {
			// K
			teTop[teNum++]=Te(from,to,ban[from],ban[to],1);
		} else {
			if (SorE==SELF && (fromDan<=3 || dan <=3) && CanPromote[ban[from]]) {
				teTop[teNum++]=Te(from,to,ban[from],ban[to],1);
			} else if (SorE==ENEMY && (fromDan>=7 || dan>=7) && CanPromote[ban[from]]){
				teTop[teNum++]=Te(from,to,ban[from],ban[to],1);
			}
			// ȂB
			teTop[teNum++]=Te(from,to,ban[from],ban[to],0);
		}
	}
}

// ԊpԂ܂ɐiގ̐
void Kyokumen::AddStraight(int SorE,int &teNum,Te *teTop,int from,int dir,int pin,int Rpin)
{
	if (dir==Rpin || dir==-Rpin) {
		return;
	}
	int i;
	if (pin==0 || pin==dir || pin==-dir) {
		// 󔒂̊ԁA𐶐
		for(i=dir;ban[from+i]==EMPTY;i+=dir) {
			AddMove(SorE,teNum,teTop,from,i,0);
		}
		// ̋łȂȂA֓
		if (!(ban[from+i] & SorE)) {
			AddMove(SorE,teNum,teTop,from,i,0);
		}
	}
}

//toɓ̐
void Kyokumen::MoveTo(int SorE,int &teNum,Te *teTop,int to,int* pin)
{
	int p;
	KomaInf koma;

	for(int i=0;i<12;i++) {
		if ((koma=ban[to-Direct[i]]) == EMPTY) {
			p=search(to,-Direct[i]);
			if ((ban[p]&SorE) && CanJump[i][ban[p]]) {
				AddMove(SorE,teNum,teTop,p,to-p,pin[p]);
			}
		} else {
			if ((koma&~SorE)!=OU && (koma&SorE) && (CanMove[i][koma]||CanJump[i][koma])) {
				AddMove(SorE,teNum,teTop,to-Direct[i],Direct[i],pin[to-Direct[i]]);
			}
		}
	}
}

// ۂ\B
void Kyokumen::FPrint(FILE *fp)
{
	int x,y;
	y = 0;
	fprintf(fp,"Hash:%016I64x Hand:%016I64x Kyokumen:%016I64x\n",HashVal,HandHashVal,KyokumenHashVal);

	fprintf(fp,"F");
	for (x = EHI; x >=EFU; x--) {
		if (Hand[x] > 1) {
			y = 1;
			fprintf(fp,"%s%2.2s", komaStr2[x], "OlܘZ101112131415161718"+2*Hand[x]-2);
		} else if (Hand[x] == 1) {
			y = 1;
			fprintf(fp,"%s", komaStr2[x]);
		}
	}
	if (y) {
		fprintf(fp,"\n");
	} else {
		fprintf(fp,"Ȃ\n");
	}
	fprintf(fp,"  X W V U T S R Q P \n");
	fprintf(fp,"+---------------------------+\n");
	for(y=1;y<=9;y++) {
		fprintf(fp,"|");
		for(x=9;x>=1;x--) {
			fprintf(fp,komaStr[ban[x*16+y]]);
		}
		fprintf(fp,"|%2.2s","OlܘZ" + y*2-2);
		fprintf(fp,"\n");
	}
	fprintf(fp,"+---------------------------+\n");
	fprintf(fp,"F");
	y = 0;
	for (x = SHI; x >= SFU; x--) {
		if (Hand[x] > 1) {
			y = 1;
			fprintf(fp,"%s%2.2s", komaStr2[x], "OlܘZ101112131415161718"+2*Hand[x]-2);
		} else if (Hand[x] == 1) {
			y = 1;
			fprintf(fp,"%s", komaStr2[x]);
		}
	}
	if (y) {
		fprintf(fp,"\n");
	} else {
		fprintf(fp,"Ȃ\n");
	}
}

// R͂ŒǉBl߂B
int kyori(int p1,int p2)
{
	return max(abs(p1/16-p2/16),abs((p1 & 0x0f)-(p2 &0x0f)));
}

int Kyokumen::IsCorrectMove(Te &te)
{
	if (te.from==0) {
		if (ban[te.to]!=EMPTY) return 0;
		if (te.koma==SFU) {
			// Ƒłl߂̃`FbN
			for(int dan=1;dan<=9;dan++) {
				if (ban[(te.to&0xf0)+dan]==SFU) return 0;
			}
			if (te.to==kingE+1) {
				int pin[16*11];
				MakePinInf(pin);
				if (Utifudume(SELF,te.to,pin)) return 0;
			}
		}
		if (te.koma==EFU) {
			// Ƒłl߂̃`FbN
			for(int dan=1;dan<=9;dan++) {
				if (ban[(te.to&0xf0)+dan]==EFU) return 0;
			}
			if (te.to==kingS-1) {
				int pin[16*11];
				MakePinInf(pin);
				if (Utifudume(ENEMY,te.to,pin)) return 0;
			}
		}
		return 1;
	}
	if (ban[te.from]==SOU) {
		if (controlE[te.to]!=0) {
			return 0;
		} else {
			te.capture=ban[te.to];
			return 1;
		}
	} else if (ban[te.from]==EOU) {
		if (controlS[te.to]!=0) {
			return 0;
		} else {
			te.capture=ban[te.to];
			return 1;
		}
	}
	if (ban[te.from]==SKE || ban[te.from]==EKE) {
		te.capture=ban[te.to];
		return 1;
	}
	int d=kyori(te.from,te.to);
	if (d==0) return 0;
	int dir=(te.to-te.from)/d;
	if (d==1) {
		te.capture=ban[te.to];
		return 1;
	}
	// WvȂ̂ŁArɎזȋȂǂ`FbN
	for(int i=1,pos=te.from+dir;i<d;i++,pos=pos+dir) {
		if (ban[pos]!=EMPTY) {
			return 0;
		}
	}
	te.capture=ban[te.to];
	return 1;
}

int Kyokumen::IsLegalMove(int SorE,Te &te)
{
	if (!(te.koma & SorE)) {
		// ̋łȂ𓮂Ă
		return 0;
	}
	if (te.from<OU) {
		if (Hand[te.koma]==0) return 0;
	} else {
		if (ban[te.from]!=te.koma) return 0;
	}
	if (ban[te.to] & SorE) {
		// ̋Ă
		return 0;
	}
	if (IsCorrectMove(te)) {
		// ʂɉĂȂAۂɓĒׂ
		Kyokumen kk(*this);
		kk.Move(SorE,te);
		if (SorE==SELF && kk.controlE[kk.kingS]) {
			return 0;
		}
		if (SorE==ENEMY && kk.controlS[kk.kingE]) {
			return 0;
		}
		return 1;
	}
	return 0;
}


int Kyokumen::EvalMin(Te *AtackS,int NumAtackS,Te *AtackE,int NumAtackE)
{
	int v=value;
	if (NumAtackE>0) {
		int k=0;
		while(!IsCorrectMove(AtackE[k]) && k<NumAtackE) {
			k++;
		}
		if (k==0) {
		} else if (k<NumAtackE) {
			Te t=AtackE[k];
			for(int i=k;i>0;i--) {
				AtackE[i]=AtackE[i-1];
			}
			AtackE[0]=t;
		} else {
			// Ɏ肪ȂȂB
			return v;
		}
		AtackE[0].capture=ban[AtackE[0].to];
		Move(ENEMY,AtackE[0]);
		return min(v,
			EvalMax(AtackS,NumAtackS,AtackE+1,NumAtackE-1));
	} else {
		return v;
	}
}

int Kyokumen::EvalMax(Te *AtackS,int NumAtackS,Te *AtackE,int NumAtackE)
{
	int v=value;
	if (NumAtackS>0) {
		// ז̏
		int k=0;
		while(!IsCorrectMove(AtackS[k]) && k<NumAtackS) {
			k++;
		}
		if (k==0) {
		} else if (k<NumAtackS) {
			Te t=AtackS[k];
			for(int i=k;i>0;i--) {
				AtackS[i]=AtackS[i-1];
			}
			AtackS[0]=t;
		} else {
			// Ɏ肪ȂȂB
			return v;
		}
		AtackS[0].capture=ban[AtackS[0].to];
		Move(SELF,AtackS[0]);
		return max(v,
			EvalMin(AtackS+1,NumAtackS-1,AtackE,NumAtackE));
	} else {
		return v;
	}
}
	
int Kyokumen::Eval(int position)
{
	if (ban[position]==EMPTY) {
		return 0;
	}
	if ((ban[position]&SELF) && !controlE[position]) {
		// SzȂ
		return 0;
	}
	if ((ban[position]&ENEMY) && !controlS[position]) {
		// SzȂ
		return 0;
	}

	int ret;
	Te teTop[40];
	int ToPos=position;

	// AtackCount𓾂悤ɁÃXg𓾂
	Te *AtackS=teTop;
	// ւ̗́Aőא8+jn2+pp=18B
	Te *AtackE=teTop+18;

	int AtackCountE=0;
	int AtackCountS=0;
	int pos2;

	int PromoteS,PromoteE;
	int b=1;
	int bj=1<<16;
	int i;
	int pos=ToPos;
	if ((ToPos&0x0f)<=3) {
		PromoteS=1;
	} else {
		PromoteS=0;
	}
	if ((ToPos&0x0f)>=7) {
		PromoteE=1;
	} else {
		PromoteE=0;
	}

	// jn̗͕ʂɐ
	for (i = 0; i < 8; i++) {
		pos2=pos;
		if (controlS[pos] & b) {
			pos2-=Direct[i];
			AtackS[AtackCountS].from=pos2;
			AtackS[AtackCountS].koma=ban[pos2];
			AtackS[AtackCountS].to=pos;
			if ((PromoteS || (pos2 & 0x0f)<=3) && CanPromote[AtackS[AtackCountS].koma]) {
				AtackS[AtackCountS].promote=1;
			} else {
				AtackS[AtackCountS].promote=0;
			}
			AtackCountS++;
		} else if (controlE[pos] & b) {
			pos2-=Direct[i];
			AtackE[AtackCountE].from=pos2;
			AtackE[AtackCountE].koma=ban[pos2];
			AtackE[AtackCountE].to=pos;
			if ((PromoteE || (pos2 & 0x0f)>=7) && CanPromote[AtackE[AtackCountE].koma]) {
				AtackE[AtackCountE].promote=1;
			} else {
				AtackE[AtackCountE].promote=0;
			}
			AtackCountE++;
		}
		if (ban[pos-Direct[i]]!=OU && ban[pos-Direct[i]]!=EOU) {
			while((controlS[pos2] & bj) || (controlE[pos2] & bj)) {
				pos2-=Direct[i];
				while(ban[pos2]==EMPTY) {
					pos2-=Direct[i];
				}
//				if (ban[pos2]==WALL) continue;//svȂ͂Ȃ̂
				if ((ban[pos2])&ENEMY) {
					AtackE[AtackCountE].from=pos2;
					AtackE[AtackCountE].koma=ban[pos2];
					AtackE[AtackCountE].to=pos;
					if ((PromoteE || (pos2 & 0x0f)>=7) && CanPromote[AtackE[AtackCountE].koma]) {
						AtackE[AtackCountE].promote=1;
					} else {
						AtackE[AtackCountE].promote=0;
					}
					AtackCountE++;
				} else if ((ban[pos2])&SELF) {
					AtackS[AtackCountS].from=pos2;
					AtackS[AtackCountS].koma=ban[pos2];
					AtackS[AtackCountS].to=pos;
					if ((PromoteS || (pos2 & 0x0f)<=3) && CanPromote[AtackS[AtackCountS].koma]) {
						AtackS[AtackCountS].promote=1;
					} else {
						AtackS[AtackCountS].promote=0;
					}
					AtackCountS++;
				}
			}
		}
		b<<=1;
		bj<<=1;
	}
	// jn̗
	b=1<<8;
	for(i=8;i<12;i++) {
		if (controlS[pos] & b) {
			pos2=pos-Direct[i];
			AtackS[AtackCountS].from=pos2;
			AtackS[AtackCountS].koma=ban[pos2];
			AtackS[AtackCountS].to=pos;
			if (PromoteS && CanPromote[AtackS[AtackCountS].koma]) {
				AtackS[AtackCountS].promote=1;
			} else {
				AtackS[AtackCountS].promote=0;
			}
			AtackCountS++;
		}
		if (controlE[pos] & b) {
			pos2=pos-Direct[i];
			AtackE[AtackCountE].from=pos2;
			AtackE[AtackCountE].koma=ban[pos2];
			AtackE[AtackCountE].to=pos;
			if (PromoteE && CanPromote[AtackE[AtackCountE].koma]) {
				AtackE[AtackCountE].promote=1;
			} else {
				AtackE[AtackCountE].promote=0;
			}
			AtackCountE++;
		}
		b<<=1;
	}
	// ̉lŃ\[gB
	for (i=0; i < AtackCountS-1; i++) {
		int max_id = i; int max_val = KomaValue[AtackS[i].koma];
		for (int j = i+1; j < AtackCountS ; j++) {
			int v=KomaValue[AtackS[j].koma];
			if (v < max_val) {
				max_id = j;
				max_val= v;
			} else if (v==max_val) {
				if (KomaValue[AtackS[j].koma]<KomaValue[AtackS[max_id].koma]) {
					max_id=j;
				}
			}
		}
		//őlƂ̌
		if (i!=max_id) {
			swap(AtackS[i],AtackS[max_id]);
		}
	}
	// ̉lŃ\[gB
	for (i=0; i < AtackCountE-1; i++) {
		int max_id = i; int max_val = KomaValue[AtackE[i].koma];
		for (int j = i+1; j < AtackCountE ; j++) {
			int v=KomaValue[AtackE[j].koma];
			if (v> max_val) {
				max_id = j;
				max_val= v;
			} else if (v==max_val) {
				if (KomaValue[AtackE[j].koma]>KomaValue[AtackE[max_id].koma]) {
					max_id=j;
				}
			}
		}
		//őlƂ̌
		if (i!=max_id) {
			swap(AtackE[i],AtackE[max_id]);
		}
	}

	int IsEnemy=(ban[position] & ENEMY);
	int IsSelf=!IsEnemy && ban[position]!=EMPTY;
	if (IsEnemy && AtackCountS>0) {
		int Eval=value;
		Kyokumen now(*this);
		ret=now.EvalMax(AtackS,AtackCountS,AtackE,AtackCountE)-Eval;
	} else if (IsSelf && AtackCountE>0) {
		int Eval=value;
		Kyokumen now(*this);
		ret=Eval-now.EvalMin(AtackS,AtackCountS,AtackE,AtackCountE);
	} else {
		ret=0;
	}
	return ret;
}

int Kyokumen::BestEval(int SorE)
{
	// SorÊ̗G̋i&SorE==0̋jɂāAEvalĂяoāA
	// ԂlTB
	int best=0;
	for(int suji=0x10;suji<=0x90;suji+=0x10) {
		for(int dan=1;dan<=9;dan++) {
			if ((ban[suji+dan]&SorE)==0) {
				int value=Eval(suji+dan);
				if (value>best) {
					best=value;
				}
			}
		}
	}
	if (SorE==ENEMY) return -best;
	return best;	
}

int KyokumenKomagumi::KomagumiValue[ERY+1][16*11];

int DanValue[ERY+1][10]={
//
	{0,0,0,0,0,0,0,0,0,0},
//
	{0,0,0,0,0,0,0,0,0,0},
//
	{0,0,0,0,0,0,0,0,0,0},
//
	{0,0,0,0,0,0,0,0,0,0},
//
	{0,0,0,0,0,0,0,0,0,0},
//
	{0,0,0,0,0,0,0,0,0,0},
//
	{0,0,0,0,0,0,0,0,0,0},
//
	{0,0,0,0,0,0,0,0,0,0},
//
	{0,0,0,0,0,0,0,0,0,0},
//
	{0,0,0,0,0,0,0,0,0,0},
//
	{0,0,0,0,0,0,0,0,0,0},
//
	{0,0,0,0,0,0,0,0,0,0},
//
	{0,0,0,0,0,0,0,0,0,0},
//
	{0,0,0,0,0,0,0,0,0,0},
//
	{0,0,0,0,0,0,0,0,0,0},
//
	{0,0,0,0,0,0,0,0,0,0},
//
	{0,0,0,0,0,0,0,0,0,0},
//
	{ 0,  0,15,15,15,3,1, 0, 0, 0},
//
	{ 0, 1,2,3,4,5,6,7,8,9},
//j
	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
//
	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
//
	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
//p
	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
//
	{ 0,10,10,10, 0, 0, 0,  -5, 0, 0},
//
	{ 0,1200,1200,900,600,300,-10,0,0,0},
//
	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
//
	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
//\
	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
//S
	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
//
	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
//n
	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
//
	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
//
	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
//
	{ 0, 0, 0, 0, -1, -3,-15,-15,-15, 0},
//
	{ 0,-9,-8,-7, -6, -5, -4, -3, -2,-1},
//j
	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
//
	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
//
	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
//p
	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
//
	{ 0, 0, 0, 5, 0, 0, 0,-10,-10,-10},
//
	{ 0, 0, 0, 0,10,-300,-600,-900,-1200,-1200},
//
	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
//
	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
//\
	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
//S
	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
//
	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
//n
	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
//
	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}
};

enum {
	IvsFURI,		// ԑΐU
	IvsNAKA,		// ԑΒ
	FURIvsFURI,		// U
	FURIvsI,		// Uԑ΋
	NAKAvsI,		// ԑ΋
	KAKUGAWARI,		// p
	AIGAKARI,		// |i܂͋Ԃ̑΍Rnj
	HUMEI			// `s
};

int JosekiKomagumiSGI[HUMEI+1][9][9]=
{
	{	// IvsFURI M͂AZA⊥
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10, -7,-10,-10,-10,-10,-10,  7,-10},
		{-10,  7, -8, -7, 10,-10, 10,  6,-10},
		{-10, -2, -6, -5,-10,  6,-10,-10,-10},
		{-10, -7,  0,-10,-10,-10,-10,-10,-10}
	},{	// IvsNAKA@M͂
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10, -7,-10,-10, -7,-10,-10,  7,-10},
		{-10, -5, -8, -7, 10,-10, 10,  6,-10},
		{-10, -2, -3,  0,-10,  6,-10,-10,-10},
		{-10, -7, -5,-10,-10,-10,-10,-10,-10}
	},{ // FURIvsFURI@qitjAZA⊥
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10, -7, -7,-10},
		{-10,-10,-10,-10,-10,  5, 10, 10,-10},
		{-10,-10,-10,-10,-10,-10,  0,-10,-10},
		{-10,-10,-10,-10,-10,-10, -5,-10,-10}
	},{ // FURIvsI Z͂A⊥
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10, -3, -7,-10,-10,-10,-10,-10},
		{-10, -7,  4,  6,-10,-10,-10,  6,-10},
		{-10,  2,  3,  3,-10,-10,  4,-10,-10},
		{-10,-10,-10,  0,-10,-10,  0,-10,-10}
	},{ // NAKAvsI 
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,  8,  5,  8,-10,-10,-10},
		{-10,-10,  4,  4,  3,  4,  4,-10,-10},
		{-10,-10,  0,-10,-10,-10,  0,-10,-10}
	},{ // KAKUGAWARI
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,  7,  5, -3,-10,-10},
		{-10,  8, 10,  7,  4,  0, -4,-10,-10},
		{-10,  0,-8,  -4,-10,-10, -5,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10}
	},{ // AIGAKARI
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,  0,-10,-10,-10,-10,-10,-10},
		{-10, -5,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10}
	},{ // HUMEI
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,  5,-10,-10},
		{-10,-10,-10,-10,-10,-10, -4,  0,-10},
		{-10,-10,  0,-10,-10,-10, -4, -3,-10},
		{-10, -5,-10, -5,-10,-10, -5,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10}
	}
};

int JosekiKomagumiSKI[HUMEI+1][9][9]=
{
	{	// IvsFURI
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,  1,  2,-10,-10,-10,-10},
		{-10,-10,-10,  0,-10, -4,-10,-10,-10}
	},{	// IvsNAKA
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,  1,  2,-10,-10,-10,-10},
		{-10,-10,-10,  0,-10, -4,-10,-10,-10}
	},{ // FURIvsFURI
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,  7, -3,-10,-10},
		{-10,-10,-10,-10,  5,  3,  6,-10,-10},
		{-10,-10,-10,-10,-10,  5,  4,-10,-10}
	},{ // FURIvsI
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,  5,  1,-10,-10},
		{-10,-10,-10,-10,  4,  3,  7, -3,-10},
		{-10,-10,-10,  0,  1,  5,  2, -7,-10}
	},{ // NAKAvsI
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10, -7, -4, -4,-10, -4, -4, -7,-10},
		{-10, -5, 10,  6,-10,  8, 10, -5,-10},
		{-10, -7, -6, -3, -6, -3, -6, -7,-10}
	},{ // KAKUGAWARI
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,  6, -4, -4, -4, -8,-10},
		{-10,-10, 10,-10,  3,  0,  0, -7,-10},
		{-10,-10,-10,  0,-10,  0, -5, -7,-10}
	},{ // AIGAKARI
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,  6,-10,-10,-10,-10,-10},
		{-10,-10, 10,-10,  3,-10,-10,-10,-10},
		{-10,-10,-10,  0,-10,  0,-10,-10,-10}
	},{ // HUMEI
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,  3,-10,  5,-10,-10,-10,-10},
		{-10,-10,-10,  0,-10,  0,-10,-10,-10}
	}
};

int JosekiKomagumiSOU[HUMEI+1][9][9]=
{
	{	// IvsFURI
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{- 7,  9,-10,-10,-10,-10,-10,-10,-10},
		{  5,  7,  8,  4,-10,-10,-10,-10,-10},
		{ 10,  5,  3,-10,-10,-10,-10,-10,-10}
	},{	// IvsNAKA
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{- 7,  9,-10,-10,-10,-10,-10,-10,-10},
		{  5,  7,  8,  4,-10,-10,-10,-10,-10},
		{ 10,  5,  3,-10,-10,-10,-10,-10,-10}
	},{ // FURIvsFURI
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,  4,  6, 10,  6},
		{-10,-10,-10,-10,-10,  4,  6,  5, 10}
	},{ // FURIvsI
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,  4,  6, 10,  6},
		{-10,-10,-10,-10,-10,  4,  6,  5, 10}
	},{ // NAKAvsI
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,  4,  6, 10,  6},
		{-10,-10,-10,-10,-10,  4,  6,  5, 10}
	},{ // KAKUGAWARI
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{- 3, -4, -3,-10,-10,-10,-10,-10,-10},
		{  6,  8, -2,  0, -3,-10,-10,-10,-10},
		{ 10,  6, -4,- 6,- 7,-10,-10,-10,-10}
	},{ // AIGAKARI
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{- 3, -4, -3,-10,-10,-10,-10,-10,-10},
		{  6,  8,  0,- 4,-10,-10,-10,-10,-10},
		{ 10,  6, -4,- 6,- 7,-10,-10,-10,-10}
	},{ // HUMEI
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{-10,-10,-10,-10,-10,-10,-10,-10,-10},
		{- 3, -4, -3,-10,-10,-10,-10,-10,-10},
		{  6,  8,  0,- 4,-10,-10,-10,-10,-10},
		{ 10,  6, -4,- 6,- 7,-10,-10,-10,-10}
	}
};

int JosekiKomagumi[9][ERY+1][16*11];

void KyokumenKomagumi::Initialize()
{
	int suji,dan,koma;
	for(suji=0x10;suji<=0x90;suji+=0x10) {
		for(dan=1;dan<=9;dan++) {
			for(koma=SFU;koma<=ERY;koma++) {
				KomagumiValue[koma][suji+dan]=0;
				JosekiKomagumi[0][koma][suji+dan]=DanValue[koma][dan];
			}
		}
	}
}

void KyokumenKomagumi::SenkeiInit()
{
	int SHI1,SHI2;
	int EHI1,EHI2;
	int SKA1,SKA2;
	int EKA1,EKA2;
	int suji,dan,koma;
	SHI1=SHI2=EHI1=EHI2=SKA1=SKA2=EKA1=EKA2=0;
	for(suji=0x10;suji<=0x90;suji+=0x10) {
		for(dan=1;dan<=9;dan++) {
			if (ban[suji+dan]==SHI) {
				if (SHI1==0) SHI1=suji+dan; else SHI2=suji+dan;
			}
			if (ban[suji+dan]==EHI) {
				if (EHI1==0) EHI1=suji+dan; else EHI2=suji+dan;
			}
			if (ban[suji+dan]==SKA) {
				if (SKA1==0) SKA1=suji+dan; else SKA2=suji+dan;
			}
			if (ban[suji+dan]==EKA) {
				if (EKA1==0) EKA1=suji+dan; else EKA2=suji+dan;
			}
		}
	}
	if (Hand[SHI]==1) if (SHI1==0) SHI1=1; else SHI2=1;
	if (Hand[SHI]==2) SHI1=SHI2=1;
	if (Hand[EHI]==1) if (EHI1==0) EHI1=1; else EHI2=1;
	if (Hand[EHI]==2) EHI1=EHI2=1;
	if (Hand[SKA]==1) if (SKA1==0) SKA1=1; else SKA2=1;
	if (Hand[SKA]==2) SKA1=SKA2=1;
	if (Hand[EKA]==1) if (EKA1==0) EKA1=1; else EKA2=1;
	if (Hand[EKA]==2) EKA1=EKA2=1;

	int Senkei,GyakuSenkei;
	if (SHI1<=0x50 && EHI1<=0x50) {
		Senkei=IvsFURI;
		GyakuSenkei=FURIvsI;
	} else if (0x50<=EHI1 && EHI1<=0x5f && SHI1<=0x50) {
		Senkei=IvsNAKA;
		GyakuSenkei=NAKAvsI;
	} else if (SHI1<=0x5f && EHI1<=0x5f) {
		Senkei=FURIvsFURI;
		GyakuSenkei=FURIvsFURI;
	} else if (EHI1>=0x60 && SHI1>=0x60) {
		Senkei=FURIvsI;
		GyakuSenkei=IvsFURI;
	} else if (0x50<=SHI1 && SHI1<=0x5f && EHI1<=0x50) {
		Senkei=NAKAvsI;
		GyakuSenkei=IvsNAKA;
	} else if (SKA1==1 && EKA1==1) {
		Senkei=KAKUGAWARI;
		GyakuSenkei=KAKUGAWARI;
	} else if (0x20<=SHI1 && SHI1<=0x2f && 0x80<=EHI1 && EHI1<=0x8f) {
		Senkei=AIGAKARI;
		GyakuSenkei=AIGAKARI;
	} else {
		Senkei=HUMEI;
		GyakuSenkei=HUMEI;
	}
	for(suji=0x10;suji<=0x90;suji+=0x10) {
		for(dan=1;dan<=9;dan++) {
			value-=KomagumiValue[ban[suji+dan]][suji+dan];
			for(koma=SFU;koma<=ERY;koma++) {
				if (koma==SGI) {
					JosekiKomagumi[Senkei][koma][suji+dan]=JosekiKomagumiSGI[Senkei][dan-1][9-(suji/0x10)];
				} else if (koma==EGI) {
					JosekiKomagumi[Senkei][koma][suji+dan]=-JosekiKomagumiSGI[GyakuSenkei][9-dan][suji/0x10-1];
				} else if (koma==SKI) {
					JosekiKomagumi[Senkei][koma][suji+dan]=JosekiKomagumiSKI[Senkei][dan-1][9-(suji/0x10)];
				} else if (koma==EKI) {
					JosekiKomagumi[Senkei][koma][suji+dan]=-JosekiKomagumiSKI[GyakuSenkei][9-dan][suji/0x10-1];
				} else if (koma==SOU) {
					JosekiKomagumi[Senkei][koma][suji+dan]=JosekiKomagumiSOU[Senkei][dan-1][9-(suji/0x10)];
				} else if (koma==EOU) {
					JosekiKomagumi[Senkei][koma][suji+dan]=-JosekiKomagumiSOU[GyakuSenkei][9-dan][suji/0x10-1];
				} else {
					JosekiKomagumi[Senkei][koma][suji+dan]=DanValue[koma][dan];
				}
				KomagumiValue[koma][suji+dan]=JosekiKomagumi[Senkei][koma][suji+dan];
			}
			value+=KomagumiValue[ban[suji+dan]][suji+dan];
		}
	}
}

void KyokumenKomagumi::Move(int SorE,const Te &te)
{
	value-=KomagumiValue[te.koma][te.from];
	if (te.capture) {
		value-=KomagumiValue[te.capture][te.to];
	}
	if (!te.promote) {
		value+=KomagumiValue[te.koma][te.to];
	} else {
		value+=KomagumiValue[te.koma|PROMOTED][te.to];
	}
	Kyokumen::Move(SorE,te);
}
